diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index 1e2ae2b5655..0808cadeeef 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -4083,13 +3072,8 @@ exploded_path::feasible2_p (logger *logger, feasibility_problem **out,
 		  model.dump_to_pp (logger->get_printer (), true, false);
 		}
 	      if (out)
-		{
-		  /* FIXME: ideally feasibility_problem should use a
-		     region_model2.  However, I don't think the model
-		     is used; it's for debugging.  */
-		  *out = new feasibility_problem (edge_idx, /*model, */ *eedge,
-						  last_stmt);
-		}
+		*out = new feasibility_problem (edge_idx, model, *eedge,
+						last_stmt);
 	      return false;
 	    }
 	}
diff --git a/gcc/analyzer/exploded-graph.h b/gcc/analyzer/exploded-graph.h
index bfdcee3af87..003bded829d 100644
--- a/gcc/analyzer/exploded-graph.h
+++ b/gcc/analyzer/exploded-graph.h
@@ -25,74 +25,6 @@ along with GCC; see the file COPYING3.  If not see
 
 namespace ana {
 
-/* Concrete implementation of region_model_context, wiring it up to the
-   rest of the analysis engine.  */
-
-class impl_region_model_context : public region_model_context
-{
- public:
-  impl_region_model_context (exploded_graph &eg,
-			     const exploded_node *enode_for_diag,
-
-			     /* TODO: should we be getting the ECs from the
-				old state, rather than the new?  */
-			     const program_state *old_state,
-			     program_state *new_state,
-			     state_change *change,
-
-			     const gimple *stmt,
-			     stmt_finder *stmt_finder = NULL);
-
-  impl_region_model_context (program_state *state,
-			     state_change *change,
-			     const extrinsic_state &ext_state,
-			     logger *logger = NULL);
-
-  void warn (pending_diagnostic *d) FINAL OVERRIDE;
-
-  void remap_svalue_ids (const svalue_id_map &map) FINAL OVERRIDE;
-
-  int on_svalue_purge (svalue_id first_unused_sid,
-		       const svalue_id_map &map) FINAL OVERRIDE;
-
-  logger *get_logger () FINAL OVERRIDE
-  {
-    return m_logger.get_logger ();
-  }
-
-  void on_state_leak (const state_machine &sm,
-		      int sm_idx,
-		      svalue_id sid,
-		      svalue_id first_unused_sid,
-		      const svalue_id_map &map,
-		      state_machine::state_t state);
-
-  void on_inherited_svalue (svalue_id parent_sid,
-			    svalue_id child_sid) FINAL OVERRIDE;
-
-  void on_cast (svalue_id src_sid,
-		svalue_id dst_sid) FINAL OVERRIDE;
-
-  void on_condition (tree lhs, enum tree_code op, tree rhs) FINAL OVERRIDE;
-
-  void on_unknown_change (svalue_id sid ATTRIBUTE_UNUSED) FINAL OVERRIDE;
-
-  void on_phi (const gphi *phi, tree rhs) FINAL OVERRIDE;
-
-  void on_unexpected_tree_code (tree t,
-				const dump_location_t &loc) FINAL OVERRIDE;
-
-  exploded_graph *m_eg;
-  log_user m_logger;
-  const exploded_node *m_enode_for_diag;
-  const program_state *m_old_state;
-  program_state *m_new_state;
-  state_change *m_change;
-  const gimple *m_stmt;
-  stmt_finder *m_stmt_finder;
-  const extrinsic_state &m_ext_state;
-};
-
 /* Concrete implementation of region_model_context, wiring it up to the
    rest of the analysis engine.  */
 
@@ -106,15 +38,13 @@ class impl_region_model2_context : public region_model2_context
 				old state, rather than the new?  */
 			     const program_state *old_state,
 			     program_state *new_state,
-			     state_change *change,
 
 			     const gimple *stmt,
 			     stmt_finder *stmt_finder = NULL);
 
   impl_region_model2_context (program_state *state,
-			     state_change *change,
-			     const extrinsic_state &ext_state,
-			     logger *logger = NULL);
+			      const extrinsic_state &ext_state,
+			      logger *logger = NULL);
 
   void warn (pending_diagnostic *d) FINAL OVERRIDE;
   void on_svalue2_leak (const svalue2 *) OVERRIDE;
@@ -146,7 +76,6 @@ class impl_region_model2_context : public region_model2_context
   const exploded_node *m_enode_for_diag;
   const program_state *m_old_state;
   program_state *m_new_state;
-  state_change *m_change;
   const gimple *m_stmt;
   stmt_finder *m_stmt_finder;
   const extrinsic_state &m_ext_state;
@@ -299,22 +228,11 @@ class exploded_node : public dnode<eg_traits>
   on_stmt_flags on_stmt (exploded_graph &eg,
 			 const supernode *snode,
 			 const gimple *stmt,
-			 program_state *state,
-			 state_change *change) const;
-  on_stmt_flags on_stmt2 (exploded_graph &eg,
-			  const supernode *snode,
-			  const gimple *stmt,
-			  program_state *state,
-			  state_change *change) const;
+			 program_state *state) const;
   bool on_edge (exploded_graph &eg,
 		const superedge *succ,
 		program_point *next_point,
-		program_state *next_state,
-		state_change *change) const;
-  void on_longjmp (exploded_graph &eg,
-		   const gcall *call,
-		   program_state *new_state,
-		   region_model_context *ctxt) const;
+		program_state *next_state) const;
   void on_longjmp2 (exploded_graph &eg,
 		    const gcall *call,
 		    program_state *new_state,
@@ -389,8 +307,6 @@ class exploded_edge : public dedge<eg_traits>
     virtual void print (pretty_printer *pp) = 0;
 
     /* Hook for updating MODEL within exploded_path::feasible_p.  */
-    virtual void update_model (region_model *model,
-			       const exploded_edge &eedge) = 0;
     virtual void update_model2 (region_model2 *model,
 				const exploded_edge &eedge) = 0;
 
@@ -401,7 +317,7 @@ class exploded_edge : public dedge<eg_traits>
   exploded_edge (exploded_node *src, exploded_node *dest,
 		 const extrinsic_state &ext_state,
 		 const superedge *sedge,
-		 const state_change &change,
+		 /*const state_change &change, */
 		 custom_info_t *custom_info);
   ~exploded_edge ();
   void dump_dot (graphviz_out *gv, const dump_args_t &args)
@@ -410,7 +326,7 @@ class exploded_edge : public dedge<eg_traits>
   //private:
   const superedge *const m_sedge;
 
-  const state_change m_change;
+  //const state_change m_change;
 
   /* NULL for most edges; will be non-NULL for special cases
      such as an unwind from a longjmp to a setjmp, or when
@@ -440,8 +356,6 @@ public:
     pp_string (pp, "rewind");
   }
 
-  void update_model (region_model *model,
-		     const exploded_edge &eedge) FINAL OVERRIDE;
   void update_model2 (region_model2 *model,
 		      const exploded_edge &eedge) FINAL OVERRIDE;
 
@@ -842,11 +756,11 @@ public:
   exploded_node *get_or_create_node (const program_point &point,
 				     const program_state &state,
 				     const exploded_node *enode_for_diag,
-				     state_change *change,
+				     /*state_change *change, */
 				     bool is_split = false);
   exploded_edge *add_edge (exploded_node *src, exploded_node *dest,
 			   const superedge *sedge,
-			   const state_change &change,
+			   /*const state_change &change,*/
 			   exploded_edge::custom_info_t *custom = NULL);
 
   per_program_point_data *
@@ -970,12 +884,13 @@ class feasibility_problem
 {
 public:
   feasibility_problem (unsigned eedge_idx,
-		       const region_model &model,
+		       const region_model2 &model,
 		       const exploded_edge &eedge,
 		       const gimple *last_stmt)
   : m_eedge_idx (eedge_idx), m_model (model), m_eedge (eedge),
     m_last_stmt (last_stmt)
   {}
+#if 0
   feasibility_problem (unsigned eedge_idx,
 		       const exploded_edge &eedge,
 		       const gimple *last_stmt)
@@ -985,9 +900,10 @@ public:
     /* FIXME: eventually remove this in favor of porting fully to
        region_model2.  */
   }
+#endif
 
   unsigned m_eedge_idx;
-  region_model m_model;
+  region_model2 m_model;
   const exploded_edge &m_eedge;
   const gimple *m_last_stmt;
 };
